
(function($) {

Drupal.dqx_adminmenu = {};

/**
 * Apply JavaScript-based hovering behaviors.
 *
 * @todo This has to run last.  If another script registers additional behaviors
 *   it will not run last.
 */
Drupal.dqx_adminmenu.init = function ($divRoot) {

  $('body').addClass('dqx_adminmenu');
  
  // Redirect destination
  $('a.dqx_adminmenu-redirect', $divRoot).each(function(){
    var href = this.href;
    if (href.split('?').length < 2) {
      this.href += '?' + Drupal.settings.dqx_adminmenu.destination;
    }
    else if (href.split('?destination=').length > 1) {
      // do nothing
    } else if (href.split('?')[1].split('&destination=').length > 1) {
      // do nothing
    } else {
      this.href += '&' + Drupal.settings.dqx_adminmenu.destination;
    }
  });
  
  // Hover emulation for IE 6.
  if ($.browser.msie && parseInt(jQuery.browser.version) == 6) {
    $('li, tr', $divRoot).hover(
      function () {
        $(this).addClass('iehover');
      },
      function () {
        $(this).removeClass('iehover');
      }
    );
  }

  // Delayed mouseout - tr/ul
  $('li.expandable, tr.expandable', $divRoot).hover(
    function () {
      // Stop the timer.
      clearTimeout(this.sfTimer);
      // Display child lists.
      var $submenu = $('> ul, > td > ul, > td > div > ul, > table', this);
      $submenu.css({left: 'auto', display: 'block'});
      // Immediately hide nephew lists.
      $siblings = $(this).siblings('li, tr');
      $('> ul, > td > ul, > td > div > ul, > table', $siblings).css({left: '-999em', display: 'none'});
    },
    function () {
      // Start the timer.
      var $submenu = $('> ul, > td > ul, > td > div > ul, > table', this);
      this.sfTimer = setTimeout(function () {
        $submenu.css({left: '-999em', display: 'none'});
      }, 400);
    }
  );
};

/**
 * @} End of "defgroup admin_behaviors".
 */

})(jQuery);
